#!/bin/bash

. ./config

usage() {

cat <<EOF
Executes pocketsphinx_continuous program

Usage: ./test.sh [language model]

Arguments:
  gram        Use a grammar base language model (default).
  stat        Use a statistical language model.
  -h, --help  Display help information and exit.
EOF
    exit
}

LM_OPTS="-jsgf $LANGUAGE_MODEL_FILE"
case "$1" in
    gram|"")
        ;;
    stat)
        LM_OPTS="-lm $STATISTICAL_LANGUAGE_MODEL_FILE"
        ;;
    *|--help|-h)
        usage;;
esac

pocketsphinx_continuous -hmm $MODEL_ADAPTED_HOME -dict $PRONUNCIATION_DICT $LM_OPTS
